# if we have reached the marker closest to the target, move to the target
execute as @e[tag=end,scores={open=1}] run scoreboard players set @s open 0
execute as @e[tag=end,scores={open=0}] run scoreboard players reset @e[scores={open=1}] open
execute if entity @e[tag=marker,scores={open=1}] run function data:astar

# move to the entity closest to use that is also in the closd list (open = 0)
execute if entity @e[tag=start] as @e[tag=unit] at @s facing entity @e[scores={open=0},sort=nearest,limit=1] feet run tp ^ ^ ^.1
execute if entity @e[tag=start] as @e[tag=unit] run function data:find_pos 
execute if entity @e[tag=start] as @e[tag=unit] at @s if score @s posX = @e[tag=marker,sort=nearest,limit=1] posX if score @s posY = @e[tag=marker,sort=nearest,limit=1] posY run scoreboard players reset @e[tag=marker,sort=nearest,limit=1] open
execute if entity @e[tag=start] unless entity @e[tag=marker,scores={open=0}] as @e[tag=unit] at @s facing entity @e[tag=target] feet run tp ^ ^ ^.1

# remove tags
execute if entity @e[tag=start] as @e[tag=unit] at @s if score @s posX = @e[tag=target,sort=nearest,limit=1] posX if score @s posY = @e[tag=target,sort=nearest,limit=1] posY as @e run tag @s remove current
execute if entity @e[tag=start] as @e[tag=unit] at @s if score @s posX = @e[tag=target,sort=nearest,limit=1] posX if score @s posY = @e[tag=target,sort=nearest,limit=1] posY run tag @s remove starting_node_unit
execute if entity @e[tag=start] as @e[tag=unit] at @s if score @s posX = @e[tag=target,sort=nearest,limit=1] posX if score @s posY = @e[tag=target,sort=nearest,limit=1] posY run tag @e[tag=marker,tag=end,limit=1] remove end
execute if entity @e[tag=start] as @e[tag=unit] at @s if score @s posX = @e[tag=target,sort=nearest,limit=1] posX if score @s posY = @e[tag=target,sort=nearest,limit=1] posY run tag @e[tag=marker,tag=start,limit=1] remove start
