## Run from tf_raycast:start_raycast

# Using dx for precise hitbox detection
# Parameters:
#     Edit not_mob.json in tags/entities to change which entities will not be targetted
#     Change the "positioned" offsets to change projectile size
#       - If > 1 block, just use one dx detection
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=3] if entity @s[dx=-3] run execute at @s run tellraw @p[tag=!sghit2] {"text":"+40 Xp(Hit an Entity)","color":"green"}
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=3] if entity @s[dx=-3] run execute at @s run playsound minecraft:entity.experience_orb.pickup master @a ~ ~ ~ 0.2 1 0.2
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=3] if entity @s[dx=-3] run execute at @s run xp add @p[tag=!sghit2] 40 levels
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=3] if entity @s[dx=-3] run execute at @s run tag @p add sghit2
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=3] if entity @s[dx=-3] run function dbsg:collide

scoreboard players add .distance tf_rc 1

# Make raycast visible
particle smoke ~ ~ ~ 0.25 0.25 0.25 0 10 normal


# Repeat the raycast if certain conditions are met
# Parameters:
#    (score after "matches") * (accuracy increment) = range
#    The "positioned" value specifies the precision
#    Edit raycast_pass.json in tags/blocks to change which blocks the raycast ignores
#    "rotated" controls arc/curve of raycast path
execute if score .distance tf_rc matches ..30 positioned ^ ^ ^0.1 rotated ~ ~ if block ~ ~ ~ #tf_raycast1:raycast_pass run function dbsg:raycast
execute if score .distance tf_rc matches 30.. run tag @p[tag=sghit2] remove sghit2
